"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const sinon_1 = require("sinon");
const open_authentication_handler_1 = require("./open-authentication-handler");
describe('open authentication handler', () => {
    let authenticationHandler;
    it('creates the handler', () => {
        authenticationHandler = new open_authentication_handler_1.default();
        chai_1.expect(typeof authenticationHandler.isValidUser).to.equal('function');
        chai_1.expect(authenticationHandler.description).to.equal('none');
    });
    it('permissions users without auth data', () => {
        const callback = sinon_1.spy();
        authenticationHandler.isValidUser(null, {}, callback);
        chai_1.expect(callback).to.have.been.calledWith(true, { username: 'open' });
    });
    it('permissions users with a username', () => {
        const callback = sinon_1.spy();
        authenticationHandler.isValidUser(null, { username: 'Wolfram' }, callback);
        chai_1.expect(callback).to.have.been.calledWith(true, { username: 'Wolfram' });
    });
});
//# sourceMappingURL=open-authentication-handler.spec.js.map