"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const sinon_1 = require("sinon");
const noop_storage_1 = require("./noop-storage");
describe('retuns null for all values', () => {
    let noopStorage;
    before(() => {
        noopStorage = new noop_storage_1.default();
    });
    it('has created the noop storage', () => {
        chai_1.expect(noopStorage.isReady).to.equal(true);
    });
    it('tries to retrieve a non-existing value', (done) => {
        const successCallback = sinon_1.spy();
        noopStorage.get('firstname', successCallback);
        setTimeout(() => {
            chai_1.expect(successCallback).to.have.callCount(1);
            chai_1.expect(successCallback).to.have.been.calledWith(null, -1, null);
            done();
        }, 1);
    });
    it('tries to delete a value', (done) => {
        const successCallback = sinon_1.spy();
        noopStorage.delete('firstname', successCallback);
        setTimeout(() => {
            chai_1.expect(successCallback).to.have.callCount(1);
            chai_1.expect(successCallback).to.have.been.calledWith(null);
            done();
        }, 1);
    });
});
//# sourceMappingURL=noop-storage.spec.js.map