"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const configCompiler = require('./config-compiler');
describe('compiles user entered config specs into an optimized format', () => {
    it('exposes a compile method', () => {
        chai_1.expect(typeof configCompiler.compile).to.equal('function');
    });
    it('compiles a basic config', () => {
        const conf = {
            record: {
                'user/$userId': {
                    write: '$userId === user.id'
                }
            }
        };
        const compiledConf = configCompiler.compile(conf);
        chai_1.expect(Array.isArray(compiledConf.record)).to.equal(true);
        chai_1.expect(compiledConf.record.length).to.equal(1);
        chai_1.expect(compiledConf.record[0].regexp).to.not.equal(undefined);
        chai_1.expect(compiledConf.record[0].variables).to.deep.equal(['$userId']);
        chai_1.expect(compiledConf.record[0].rules.write.fn).to.not.equal(undefined);
        chai_1.expect(compiledConf.record[0].rules.write.hasOldData).to.equal(false);
    });
});
//# sourceMappingURL=config-compiler.spec.js.map