"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const C = require("../constants");
exports.deletionMsg = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.DELETE,
    name: 'someRecord'
};
exports.deletionSuccessMsg = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.DELETE_SUCCESS,
    name: 'someRecord'
};
exports.anotherDeletionMsg = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.DELETE,
    name: 'no-storage/1'
};
exports.anotherDeletionSuccessMsg = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.DELETE_SUCCESS,
    name: 'no-storage/1'
};
exports.subscribeCreateAndReadMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.SUBSCRIBECREATEANDREAD,
    name: 'some-record'
};
exports.readResponseMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.READ_RESPONSE,
    name: 'some-record',
    version: 0,
    parsedData: {}
};
exports.subscribeCreateAndReadPermissionErrorMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.MESSAGE_PERMISSION_ERROR,
    originalAction: C.RECORD_ACTIONS.SUBSCRIBECREATEANDREAD,
    name: 'some-record'
};
exports.subscribeCreateAndReadDeniedMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.MESSAGE_DENIED,
    originalAction: C.RECORD_ACTIONS.SUBSCRIBECREATEANDREAD,
    name: 'some-record'
};
exports.subscribeMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.SUBSCRIBE,
    name: 'some-record'
};
exports.unsubscribeMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.UNSUBSCRIBE,
    name: 'some-record'
};
exports.recordSnapshotMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.READ,
    name: 'some-record'
};
exports.recordHeadMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.HEAD,
    name: 'some-record'
};
exports.recordHeadResponseMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.HEAD_RESPONSE,
    name: 'some-record'
};
exports.recordData = { name: 'Kowalski' };
exports.recordVersion = 5;
exports.recordUpdate = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.UPDATE,
    name: 'some-record',
    version: exports.recordVersion + 1,
    parsedData: exports.recordData,
    isWriteAck: false
};
exports.recordUpdateWithAck = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.UPDATE,
    name: 'some-record',
    version: -1,
    parsedData: exports.recordData,
    isWriteAck: true
};
exports.recordPatch = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.PATCH,
    name: 'some-record',
    version: exports.recordVersion + 1,
    path: 'lastname',
    parsedData: 'Egon',
    isWriteAck: false
};
exports.recordPatchWithAck = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.PATCH,
    name: 'some-record',
    version: 4,
    path: 'lastname',
    parsedData: 'Egon',
    isWriteAck: true
};
exports.recordDelete = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.DELETE,
    name: 'some-record'
};
exports.createAndUpdate = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.CREATEANDUPDATE,
    name: 'some-record',
    version: -1,
    parsedData: exports.recordData,
    isWriteAck: false
};
exports.listenAcceptMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.LISTEN_ACCEPT,
    name: 'record/.*',
    subscription: 'record/A'
};
exports.listenRejectMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.LISTEN_REJECT,
    name: 'record/.*',
    subscription: 'record/A'
};
exports.unlistenMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.UNLISTEN,
    name: 'record/.*'
};
exports.listenMessage = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.LISTEN,
    name: 'record/.*'
};
exports.writeAck = {
    topic: C.TOPIC.RECORD,
    action: C.RECORD_ACTIONS.WRITE_ACKNOWLEDGEMENT,
    name: 'some-record',
    data: [[-1], null]
};
//# sourceMappingURL=test-messages.js.map